Attribute VB_Name = "modBPM"
'============================================================================
' modBPM.bas - Copyright (c) 2003-2005 (: JOBnik! :) [Arthur Aminov, ISRAEL]
'                                                    [http://www.jobnik.org]
'                                                    [   bass_fx@jobnik.org]
' Other source: frmBPM.frm
'
' BASS_FX bpm with tempo & Rate
' * Requires: BASS.DLL & BASS.BAS 2.2 available @ www.un4seen.com
'============================================================================

Option Explicit

Public chan As Long                 'a tempo handle
Public hBPM As Long                 'decoding bpm handle
Public orgBPM As Single             'original bpm

Public Const maxp As Single = 1.3   'increase rate for max 30%
Public Const minp As Single = 0.7   'decrease rate for min 30%

' show the approximate position in MM:SS format
Public Sub UpdatePositionLabel()
    Dim totalsec As Single, posec As Single

    If (BASS_FX_TempoGetRateRatio(chan)) Then
        With frmBPM
            totalsec = .sldPosition.max / BASS_FX_TempoGetRateRatio(chan)
            posec = .sldPosition.value / BASS_FX_TempoGetRateRatio(chan)
    
            .sldPosition.Text = Format(Int(posec) \ 60, "00") & ":" & Format(Int(posec) Mod 60, "00") & " / " & _
                                Format(Int(totalsec) \ 60, "00") & ":" & Format(Int(totalsec) Mod 60, "00")
            .lblPos.Caption = "Playing position: " & .sldPosition.Text
        End With
    End If
End Sub

Public Function GetNewBPM(ByVal hBPM As Long) As Single
    GetNewBPM = BASS_FX_BPM_Translate(hBPM, BASS_FX_TempoGetRateRatio(chan) * 100#, BASS_FX_BPM_PERCENT2)
    
    ' or you could do it this way too :)
    ' GetNewBPM = orgBPM * BASS_FX_TempoGetRateRatio(chan)
End Function

Public Sub DecodingBPM(ByVal newStream As Boolean, ByVal startSec As Single, ByVal endSec As Single)
    If newStream Then
        ' Open file for bpm decoding detection
        hBPM = BASS_StreamCreateFile(BASSFALSE, frmBPM.CMD.FileName, 0, 0, BASS_STREAM_DECODE)
        If (hBPM = 0) Then hBPM = BASS_MusicLoad(BASSFALSE, frmBPM.CMD.FileName, 0, 0, BASS_MUSIC_DECODE Or BASS_MUSIC_PRESCAN, 0)
    End If

    orgBPM = BASS_FX_BPM_DecodeGet(hBPM, startSec, endSec, 0, BASS_FX_BPM_BKGRND Or BASS_FX_BPM_MULT2 Or BASS_FX_FREESOURCE, AddressOf GetBPM_Process)

    ' update the bpm view
    frmBPM.lblBPM.Caption = "BPM: " & Format(GetNewBPM(hBPM), "0.00")
End Sub

'------------------------------------------
'----------- CALLBACK FUNCTIONS -----------
'------------------------------------------

' get the bpm after period of time
Public Sub GetBPM_Callback(ByVal handle As Long, ByVal bpm As Single, ByVal user As Long)
    frmBPM.lblBPM.Caption = "BPM: " & Format(GetNewBPM(handle), "0.00")
End Sub

' get the bpm process detection in percents of a decoding channel
Public Sub GetBPM_Process(ByVal chan As Long, ByVal per As Single)
    ' update the progress bar
    frmBPM.pbProcess.value = per
End Sub

